'use client';
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.useFieldCursor = useFieldCursor;
exports.default = void 0;
var _react = require("react");
var _utils = require("../utils");
var _useUpdateEffect = _interopRequireDefault(require("../../utils/useUpdateEffect"));
function useFieldCursor(format, value) {
  var typeCount = (0, _react.useRef)(0);
  var increment = function increment() {
    typeCount.current += 1;
  };
  var reset = function reset() {
    typeCount.current = 0;
  };
  var isMoveCursor = (0, _react.useCallback)(function (value, pattern) {
    var patternGroup = (0, _utils.getPatternGroups)(format, pattern);
    if (value.toString().length === patternGroup.length) {
      return true;
    } else if (pattern === 'y' && typeCount.current === 4) {
      return true;
    } else if (pattern !== 'y' && typeCount.current === 2) {
      return true;
    }
    switch (pattern) {
      case 'M':
        return parseInt(value + "0") > 12;
      case 'd':
        return parseInt(value + "0") > 31;
      case 'H':
        return parseInt(value + "0") > 23;
      case 'h':
        return parseInt(value + "0") > 12;
      case 'm':
      case 's':
        return parseInt(value + "0") > 59;
      default:
        return false;
    }
  }, [format]);
  (0, _useUpdateEffect.default)(function () {
    if (!value) {
      reset();
    }
  }, [value]);
  return {
    increment: increment,
    reset: reset,
    isMoveCursor: isMoveCursor
  };
}
var _default = useFieldCursor;
exports.default = _default;